/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <vector>

// Forward declaration
namespace QSnd
{
class Mixer_HCTL_Elem;
}

namespace QSnd
{

/// @brief Mixer_HCTL_Elem_Group
///
class Mixer_HCTL_Elem_Group
{
  // Public methods
  public:
  void
  clear ();

  ::std::size_t
  num_elems () const
  {
    return _snd_elems.size ();
  }

  void
  append_elem ( Mixer_HCTL_Elem * elem_n )
  {
    _snd_elems.push_back ( elem_n );
  }

  Mixer_HCTL_Elem *
  elem ( ::std::size_t idx_n ) const
  {
    return _snd_elems[ idx_n ];
  }

  // Private attributes
  private:
  ::std::vector< Mixer_HCTL_Elem * > _snd_elems;
};

} // namespace QSnd
