/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include <memory>
#include <vector>

// Forward declaration
namespace QSnd
{
class Mixer_Simple_Elem;
}

namespace QSnd
{

/// @brief Mixer_Simple_Filter
///
/// Filters mixer elements from a list
///
class Mixer_Simple_Filter
{
  // Public types
  public:
  using Element_Vector =
      ::std::vector< ::std::unique_ptr< ::QSnd::Mixer_Simple_Elem > >;

  // Public methods
  public:
  Mixer_Simple_Filter ();

  virtual ~Mixer_Simple_Filter ();

  /// @brief Filters certain elements from accent_n to drop_n
  ///
  /// @return The number of dropped elements
  virtual ::std::size_t
  filter ( Element_Vector & accept_n, Element_Vector & drop_n ) = 0;
};

} // namespace QSnd
