/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "qsnd/alsa.hpp"
#include "qsnd/pcm_subdevices_info.hpp"
#include <QString>

namespace QSnd
{

/// @brief PCM_Device_Info
///
class PCM_Device_Info
{
  // Public methods
  public:
  PCM_Device_Info ();

  int
  dev_index () const
  {
    return _dev_index;
  }

  const QString &
  dev_id () const
  {
    return _dev_id;
  }

  const QString &
  dev_name () const
  {
    return _dev_name;
  }

  const ::QSnd::PCM_Subdevices_Info &
  subdevices_info ( ::std::size_t stream_dir_n ) const
  {
    return _sdevs_info[ stream_dir_n ];
  }

  void
  clear ();

  int
  acquire_device_info ( snd_ctl_t * snd_ctl_handle, int device_idx_n );

  // Private attributes
  private:
  int _dev_index = -1;

  QString _dev_id;
  QString _dev_name;

  ::QSnd::PCM_Subdevices_Info _sdevs_info[ 2 ];
};

} // namespace QSnd
