/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "qsnd/alsa.hpp"
#include <QString>

namespace QSnd
{

/// @brief PCM_Subdevice_Info
///
class PCM_Subdevice_Info
{
  // Public methods
  public:
  PCM_Subdevice_Info ( snd_pcm_info_t * pcm_info_n = nullptr );

  int
  dev_idx () const
  {
    return _dev_index;
  }

  const QString &
  dev_name () const
  {
    return _dev_name;
  }

  int
  acquire_info ( snd_pcm_info_t * pcm_info_n );

  // Private attributes
  private:
  int _dev_index = -1;
  QString _dev_name;
};

} // namespace QSnd
