/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "namespace_wdg.hpp"
#include "qslider.hpp"
#include <QLabel>
#include <iostream>

namespace Wdg
{

/// @brief DS_Slider_Test
///
class DS_Slider_Test : public QWidget
{
  Q_OBJECT

  public:
  // -- Construction

  DS_Slider_Test ( QWidget * parent_n = nullptr );

  ~DS_Slider_Test ();

  DS_Slider *
  slider ()
  {
    return &_slider;
  }

  protected:
  Q_SLOT
  void
  value_changed ( int value_n );

  Q_SLOT
  void
  range_changed ( int min_n, int max_n );

  // Private attributes
  private:
  DS_Slider _slider;
  QLabel _value;
  QLabel _range;
};

} // namespace Wdg
