/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "dpe/painter.hpp"

// Forward declaration
namespace dpe
{
class Image;
class Image_Set_Meta;
} // namespace dpe
namespace Wdg
{
class DS_Widget_Style_Db;
}

namespace Wdg::Painter
{

/// @brief DS_Widget_Painter
///
class DS_Widget_Painter : public ::dpe::Painter
{
  // Public methods
  public:
  // -- Construction

  DS_Widget_Painter ( unsigned int group_type_n,
                      unsigned int group_variant_n = 0 );

  ~DS_Widget_Painter ();

  // -- Widget style database

  ::Wdg::DS_Widget_Style_Db *
  wdg_style_db () const
  {
    return _wdg_style_db;
  }

  void
  set_wdg_style_db ( ::Wdg::DS_Widget_Style_Db * style_db_n );

  // Protected methods
  protected:
  int
  create_image_data ( ::dpe::Image * img_n,
                      const ::dpe::Image_Set_Meta * meta_n );

  // Private methods
  private:
  ::Wdg::DS_Widget_Style_Db * _wdg_style_db = nullptr;
};

} // namespace Wdg::Painter
