/// QasTools: Desktop toolset for the Linux sound system ALSA.
/// \copyright See COPYING file.

#pragma once

#include "wdg/pad_proxy.hpp"

namespace Wdg
{

/// @brief Pad_Proxy_Slider
///
class Pad_Proxy_Slider : public ::Wdg::Pad_Proxy
{
  Q_OBJECT;

  // Public methods
  public:
  // -- Construction

  Pad_Proxy_Slider ();

  ~Pad_Proxy_Slider ();

  unsigned long
  slider_index () const
  {
    return _slider_index;
  }

  unsigned long
  slider_index_max () const
  {
    return _slider_index_max;
  }

  // --Signals

  Q_SIGNAL
  void
  sig_slider_index_changed ( unsigned long idx_n );

  Q_SIGNAL
  void
  sig_slider_index_max_changed ( unsigned long idx_n );

  // -- Public slots

  Q_SLOT
  void
  set_slider_index ( unsigned long idx_n );

  Q_SLOT
  void
  set_slider_index_max ( unsigned long idx_n );

  // Protected methods
  protected:
  virtual void
  slider_index_changed ();

  virtual void
  slider_index_max_changed ();

  // Private attributes
  private:
  unsigned long _slider_index = 0;
  unsigned long _slider_index_max = 0;
};

} // namespace Wdg
